C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C   SUBROUTINE FOR STRUCTURE FUNCTIONS INCLUDING SELF ENERGIES
C   AND LEPTONIC QED CORRECTIONS
C   CALCULATED FROM PARTON DISTRIBUTION FUNCTIONS
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      SUBROUTINE HSSTR1(X,Q2)
      IMPLICIT DOUBLE PRECISION (A-H,M,O-Z)
      COMPLEX*16 HSSRGG,HSSRGZ,HSSRZZ,CG,CM,CZ
      COMMON /HSKNST/ PI,ALPHA,ALP1PI,ALP2PI,ALP4PI,E,GF,SXNORM,SX1NRM
      COMMON /HSUNTS/ LUNTES,LUNDAT,LUNIN,LUNOUT,LUNRND
      COMMON /HSPARL/ LPAR(20),LPARIN(12)
      COMMON /HSPDFQ/ QU,QBU,QD,QBD,QS,QBS,QC,QBC,QB,QBB,QT,QBT
      COMMON /HSFIJK/ F1(2,2),F2(2,2),F3(2,2)
      COMMON /HSSMCP/ VAFI(2,3,2),AFIJ(3,2,2),BFIJ(3,2,2),FLIND(2,3,2,2)
      COMMON /HSPARM/ POLARI,LLEPT,LQUA
      COMMON /HSELAB/ SP,EELE,PELE,EPRO,PPRO
      COMMON /HSGSW1/ MEI,MEF,MQI,MQF,MEI2,MEF2,MQI2,MQF2,MPRO,MPRO2
      COMMON /HSGSW/  SW,CW,SW2,CW2
     *              ,MW,MZ,MH,ME,MMY,MTAU,MU,MD,MS,MC,MB,MT
     *              ,MW2,MZ2,MH2,ME2,MMY2,MTAU2,MU2,MD2,MS2,MC2,MB2,MT2
      COMMON /HSDELR/ DELTAR,AGF0,DRHOT,DALPMZ,XGMT,ALPQCD,BTOP4,DRPIW2
      COMMON /HSPDFO/ IPDFOP,IFLOPT,LQCD,LTM,LHT
      COMMON /HSNUCL/ HNA,HNZ
      COMMON /HYSTFU/ PYSTOP,PYSLAM,NPYMAX,NPYMIN
      REAL*4          PYSTOP,PYSLAM
      COMMON /HSSTRP/ ICODE,ILIB,ILQMOD
C...HSRADF USED IN SUBROUTINE STRFBS (CALL TO STEIN OR BRASSE)
      COMMON /HSRADC/ AMP , AMP2,RPI ,RPI2 , ALFA, AML , AML2
      COMMON /HSRADF/ AP,AP2,AP4,AL2,AL4,ALPS,CALPI,W2PIT,W2TR,TTR
      DIMENSION VAFI1(2,3,2),AFIJ1(3,2,2),BFIJ1(3,2,2),FLIND1(2,3,2,2)
      DIMENSION DSBOS(2),DSBS1(2)
      LOGICAL LFIRST
      DATA LFIRST/.TRUE./

      IF (LFIRST) THEN
        LFIRST=.FALSE.
        W2TR=4D0
        TTR=6D0
        AMP2=MPRO2
        AP=2D0*MPRO
        W2PIT=1.15184D0
        W2MIN=1.2321D0
        S=SP
        IF (ILQMOD.EQ.4.AND.ICODE.EQ.0) THEN
          ILIB=2
          ICODE=3034
        ENDIF
        IF (ILQMOD.EQ.5.AND.ICODE.EQ.0) THEN
          ILIB=2
          ICODE=3025
        ENDIF
      ENDIF
      ZF1=0D0
      ZF2=0D0
      T=-Q2
      SHAT=SP-MEI2-MPRO2
      Y=Q2/SHAT/X
      DSBOS(1)=1D0
      DSBOS(2)=Q2/(Q2+MZ2)

      IF (ILQMOD.EQ.0.OR.ILQMOD.EQ.1) THEN
C---CALCULATE STRUCTURE FUNCTIONS FROM PARTON DISTRIBUTIONS
        GOTO 1000
      ELSEIF (ILQMOD.EQ.2) THEN
C---FOR LOW Q2 ONLY GAMMA EXCHANGE, PARAMETRIZATION BY BRASSE AND
C   STEIN, COMBINED WITH PARTON DISTRIBUTION FUNCTIONS FOR LARGE Q2
        IF (Q2.LT.TTR) THEN
          DO 4 IB1=1,2
          DO 4 IB2=1,2
          F1(IB1,IB2)=0D0
          F2(IB1,IB2)=0D0
    4     F3(IB1,IB2)=0D0
          CALL STRFBS(X,Q2,AF1,AF2)
          F1(1,1)=AF1
          F2(1,1)=AF2
C..PHOTON SELF ENERGY
          IF (LPAR(7).GE.1) THEN
            CG=HSSRGG(T)
            PIGGG=DREAL(CG)/T
            ELSE
            PIGGG=0D0
          ENDIF
          DVACGG=1D0/(1D0+PIGGG)
C..LEPTONIC QED VERTEX CORRECTIONS INCLUDING SOFT BREMSSTRAHLUNG
          IF (LPAR(12).GE.1) THEN
            DVRTXV=HSDQDV(X,Q2)*ALP2PI
            DVRTXS=HSDQDS(X,Q2)*ALP2PI
            DVRTX1=DVRTXV-(Q2+4D0*MEI2)/(Q2-2D0*MEI2)*DVRTXS
            DVRTX2=DVRTXV+
     *         (2D0*(1D0-Y)+Y*Y/2D0)/(1D0-Y-MPRO2*Q2/SHAT/SHAT)*DVRTXS
            ELSE
            DVRTX1=0D0
            DVRTX2=0D0
          ENDIF
C
          IF (LPAR(3).LT.3) THEN
          F1(1,1)=F1(1,1)*(DVRTX1+DVACGG*DVACGG)
          F2(1,1)=F2(1,1)*(DVRTX2+DVACGG*DVACGG)
          ELSE
          F1(1,1)=F1(1,1)*(1D0+DVRTX1)*DVACGG*DVACGG
          F2(1,1)=F2(1,1)*(1D0+DVRTX2)*DVACGG*DVACGG
          ENDIF
          RETURN
         ELSE
          GOTO 1000
        ENDIF
      ELSEIF (ILQMOD.EQ.3.AND.ICODE.NE.0) THEN
C---FOR LOW Q2 ONLY GAMMA EXCHANGE, PARAMETRIZATION BY ABRAMOWICZ,
C   LEVY, LEVIN, MAOR, COMBINED WITH PARTON DISTRIBUTION FUNCTIONS FOR
C   LARGE Q2 FROM MORFIN AND TUNG
        DO 6 IB1=1,2
        DO 6 IB2=1,2
        F1(IB1,IB2)=0D0
        F2(IB1,IB2)=0D0
    6   F3(IB1,IB2)=0D0
        W2=(1D0-X)/X*Q2+MPRO2
        IF(Q2.LT.TTR) THEN
          IF (W2.LT.W2TR) THEN
            CALL STRFBS(X,Q2,ZF1,ZF2)
            ELSE
            CALL HSSTAL(X,Q2,ZF1,ZF2)
          ENDIF
         ELSEIF (Q2.GE.5000D0.OR.X.GE.0.85D0) THEN
          GOTO 1000
         ELSE
          CALL HSSTAL(X,Q2,ZF1,ZF2)
        ENDIF
        F1(1,1)=ZF1
        F2(1,1)=ZF2
C..PHOTON SELF ENERGY
        IF (LPAR(7).GE.1) THEN
          CG=HSSRGG(T)
          PIGGG=DREAL(CG)/T
          ELSE
          PIGGG=0D0
        ENDIF
        DVACGG=1D0/(1D0+PIGGG)
C..LEPTONIC QED VERTEX CORRECTIONS INCLUDING SOFT BREMSSTRAHLUNG
        IF (LPAR(12).GE.1) THEN
          DVRTXV=HSDQDV(X,Q2)*ALP2PI
          DVRTXS=HSDQDS(X,Q2)*ALP2PI
          DVRTX1=DVRTXV-(Q2+4D0*MEI2)/(Q2-2D0*MEI2)*DVRTXS
          DVRTX2=DVRTXV+
     *          (2D0*(1D0-Y)+Y*Y/2D0)/(1D0-Y-MPRO2*Q2/SHAT/SHAT)*DVRTXS
          ELSE
          DVRTX1=0D0
          DVRTX2=0D0
        ENDIF
C
        IF (LPAR(3).LT.3) THEN
        F1(1,1)=F1(1,1)*(DVRTX1+DVACGG*DVACGG)
        F2(1,1)=F2(1,1)*(DVRTX2+DVACGG*DVACGG)
        ELSE
        F1(1,1)=F1(1,1)*(1D0+DVRTX1)*DVACGG*DVACGG
        F2(1,1)=F2(1,1)*(1D0+DVRTX2)*DVACGG*DVACGG
        ENDIF
        RETURN
      ELSEIF (ILQMOD.EQ.3.AND.ICODE.EQ.0) THEN
        WRITE(LUNOUT,'(//3(A/))')
     *' ***** WRONG STRUCTURE FUNCTION CODE:'
     *,'       ILQMOD = 3 AND ICODE = 0'
     *,'       EXECUTION STOPPED '
        STOP
      ELSEIF (ILQMOD.EQ.4) THEN
C---FOR LOW Q2 ONLY GAMMA EXCHANGE,
C   PARAMETRIZATION BY BADELEK AND KWIECINSKI
C   COMBINED WITH BRASSE STEIN FOR SMALL HADRONIC MASS
        DO 8 IB1=1,2
        DO 8 IB2=1,2
        F1(IB1,IB2)=0D0
        F2(IB1,IB2)=0D0
    8   F3(IB1,IB2)=0D0
        IF ((X.GT.0.1D0.AND.Q2.GT.6D0).OR.Q2.GT.998.8D0) THEN
          GOTO 1000
          ELSE
          ANU=Q2/X/2D0
          IF (ANU.LT.10D0) THEN
            CALL STRFBS(X,Q2,ZF1,ZF2)
            ELSE
            CALL HSSTBK(X,Q2,ZF1,ZF2)
          ENDIF
        ENDIF
        F1(1,1)=ZF1
        F2(1,1)=ZF2
C..PHOTON SELF ENERGY
        IF (LPAR(7).GE.1) THEN
          CG=HSSRGG(T)
          PIGGG=DREAL(CG)/T
          ELSE
          PIGGG=0D0
        ENDIF
        DVACGG=1D0/(1D0+PIGGG)
C..LEPTONIC QED VERTEX CORRECTIONS INCLUDING SOFT BREMSSTRAHLUNG
        IF (LPAR(12).GE.1) THEN
          DVRTXV=HSDQDV(X,Q2)*ALP2PI
          DVRTXS=HSDQDS(X,Q2)*ALP2PI
          DVRTX1=DVRTXV-(Q2+4D0*MEI2)/(Q2-2D0*MEI2)*DVRTXS
          DVRTX2=DVRTXV+
     *          (2D0*(1D0-Y)+Y*Y/2D0)/(1D0-Y-MPRO2*Q2/SHAT/SHAT)*DVRTXS
          ELSE
          DVRTX1=0D0
          DVRTX2=0D0
        ENDIF
C
        IF (LPAR(3).LT.3) THEN
        F1(1,1)=F1(1,1)*(DVRTX1+DVACGG*DVACGG)
        F2(1,1)=F2(1,1)*(DVRTX2+DVACGG*DVACGG)
        ELSE
        F1(1,1)=F1(1,1)*(1D0+DVRTX1)*DVACGG*DVACGG
        F2(1,1)=F2(1,1)*(1D0+DVRTX2)*DVACGG*DVACGG
        ENDIF
        F2EM=F2(1,1)
        GOTO 2000
      ELSEIF (ILQMOD.EQ.5) THEN
C---FOR LOW Q2 ONLY GAMMA EXCHANGE,
C   PARAMETRIZATION BY DONNACHIE AND LANDSHOFF
C   COMBINED WITH PARTON DISTRIBUTION FUNCTIONS FOR LARGE Q2
        DO 9 IB1=1,2
        DO 9 IB2=1,2
        F1(IB1,IB2)=0D0
        F2(IB1,IB2)=0D0
    9   F3(IB1,IB2)=0D0
        IF (Q2.GT.10D0) THEN
          GOTO 1000
          ELSE
          CALL HSSTDL(X,Q2,ZF1,ZF2)
        ENDIF
        F1(1,1)=ZF1
        F2(1,1)=ZF2
C..PHOTON SELF ENERGY
        IF (LPAR(7).GE.1) THEN
          CG=HSSRGG(T)
          PIGGG=DREAL(CG)/T
          ELSE
          PIGGG=0D0
        ENDIF
        DVACGG=1D0/(1D0+PIGGG)
C..LEPTONIC QED VERTEX CORRECTIONS INCLUDING SOFT BREMSSTRAHLUNG
        IF (LPAR(12).GE.1) THEN
          DVRTXV=HSDQDV(X,Q2)*ALP2PI
          DVRTXS=HSDQDS(X,Q2)*ALP2PI
          DVRTX1=DVRTXV-(Q2+4D0*MEI2)/(Q2-2D0*MEI2)*DVRTXS
          DVRTX2=DVRTXV+
     *          (2D0*(1D0-Y)+Y*Y/2D0)/(1D0-Y-MPRO2*Q2/SHAT/SHAT)*DVRTXS
          ELSE
          DVRTX1=0D0
          DVRTX2=0D0
        ENDIF
C
        IF (LPAR(3).LT.3) THEN
        F1(1,1)=F1(1,1)*(DVRTX1+DVACGG*DVACGG)
        F2(1,1)=F2(1,1)*(DVRTX2+DVACGG*DVACGG)
        ELSE
        F1(1,1)=F1(1,1)*(1D0+DVRTX1)*DVACGG*DVACGG
        F2(1,1)=F2(1,1)*(1D0+DVRTX2)*DVACGG*DVACGG
        ENDIF
        F2EM=F2(1,1)
        GOTO 2000
      ELSEIF (ILQMOD.EQ.10) THEN
C---FOR LOW Q2 ONLY GAMMA EXCHANGE,
C   STRUCTURE FUNCTIONS FROM USER ROUTINE
C   PARAMETRIZATION BY DONNACHIE AND LANDSHOFF
        DO 10 IB1=1,2
        DO 10 IB2=1,2
        F1(IB1,IB2)=0D0
        F2(IB1,IB2)=0D0
 10     F3(IB1,IB2)=0D0
        CALL FIUSER(X,Q2,ZF1,ZF2,IPDFR)
        IF (IPDFR.EQ.1) GOTO 1000
        F1(1,1)=ZF1
        F2(1,1)=ZF2
C..PHOTON SELF ENERGY
        IF (LPAR(7).GE.1) THEN
          CG=HSSRGG(T)
          PIGGG=DREAL(CG)/T
          ELSE
          PIGGG=0D0
        ENDIF
        DVACGG=1D0/(1D0+PIGGG)
C..LEPTONIC QED VERTEX CORRECTIONS INCLUDING SOFT BREMSSTRAHLUNG
        IF (LPAR(12).GE.1) THEN
          DVRTXV=HSDQDV(X,Q2)*ALP2PI
          DVRTXS=HSDQDS(X,Q2)*ALP2PI
          DVRTX1=DVRTXV-(Q2+4D0*MEI2)/(Q2-2D0*MEI2)*DVRTXS
          DVRTX2=DVRTXV+
     *          (2D0*(1D0-Y)+Y*Y/2D0)/(1D0-Y-MPRO2*Q2/SHAT/SHAT)*DVRTXS
          ELSE
          DVRTX1=0D0
          DVRTX2=0D0
        ENDIF
C
        IF (LPAR(3).LT.3) THEN
        F1(1,1)=F1(1,1)*(DVRTX1+DVACGG*DVACGG)
        F2(1,1)=F2(1,1)*(DVRTX2+DVACGG*DVACGG)
        ELSE
        F1(1,1)=F1(1,1)*(1D0+DVRTX1)*DVACGG*DVACGG
        F2(1,1)=F2(1,1)*(1D0+DVRTX2)*DVACGG*DVACGG
        ENDIF
        F2EM=F2(1,1)
        GOTO 2000
      ELSE
        WRITE(LUNOUT,200) ILQMOD
        STOP
  200   FORMAT(/,'          WRONG VALUE FOR ILQMOD: ',I8,/
     F          ,' ******** EXECUTION STOPPED IN HSTRF1 ',/)
      ENDIF

1000  CONTINUE
      CALL HSPVER(X,Q2)
      IF (HNA.EQ.1D0.AND.HNZ.EQ.1D0) THEN
C---PROTON TARGET
        QUT=QU+QC+QT
        QDT=QD+QS+QB
        QUBT=QBU+QBC+QBT
        QDBT=QBD+QBS+QBB
      ELSEIF (HNA.EQ.1D0.AND.HNZ.EQ.0D0) THEN
C---NEUTRON TARGET
        QDT=QU+QC+QT
        QUT=QD+QS+QB
        QDBT=QBU+QBC+QBT
        QUBT=QBD+QBS+QBB
      ELSE
C---OTHER TARGETS: FIRST CALCULATE DEUTERON STRUCTURE FUNCTIONS
C   PER NUCLEON
        QDT=(QU+QC+QT+QD+QS+QB)/2D0
        QUT=QDT
        QDBT=(QBU+QBC+QBT+QBD+QBS+QBB)/2D0
        QUBT=QDBT
      ENDIF
C
C..SELF ENERGIES
      IF (LPAR(7).GE.1) THEN
        CG=HSSRGG(T)
        PIGGG=DREAL(CG)/T
        ELSE
        PIGGG=0D0
      ENDIF
      IF (LPAR(8).EQ.1.AND.LPAR(17).EQ.0) THEN
        CM=HSSRGZ(T)
        SM=DREAL(CM)/T
        AKAPPA=1D0-CW/SW*SM/(1D0+PIGGG)
        SWEFF2=SW2*AKAPPA
        ELSE
        SM=0D0
        AKAPPA=1D0
        SWEFF2=SW2
      ENDIF
      IF (LPAR(9).EQ.1.AND.LPAR(17).EQ.0) THEN
        CZ=HSSRZZ(T)
        PIGZZ=DREAL(CZ)/(T-MZ2)
        ELSE
        PIGZZ=0D0
      ENDIF
      GMUFFQ=1D0/(1D0+PIGZZ)
      BFFQ=SQRT(GMUFFQ)*BTOP4
C
C..REDEFINE FERMION GAUGE BOSON COUPLING CONSTANTS TO INCLUDE SELF
C..ENERGIES
      IF (LPAR(4).EQ.1) THEN
        B0=1D0/4D0/CW/SW
        B=B0
        ELSE
C..NORMALIZED TO G-MU
        B0=MZ/SQRT(AGF0)/4D0
        B=B0
        IF (LPAR(9).GE.1) B=B0*SQRT(1D0-DELTAR)
      ENDIF
      IF (LPAR(2).EQ.1.AND.LPAR(9).GE.1) B=B*BFFQ
      RHO1=B/B0
      DSBS1(1)=DSBOS(1)/(1D0+PIGGG)
      DSBS1(2)=DSBOS(2)*GMUFFQ*RHO1

      VAFI1(2,1,1)=0D0
      VAFI1(2,2,1)=0D0
      VAFI1(2,3,1)=0D0
      VAFI1(2,1,2)=-B
      VAFI1(2,2,2)=B
      VAFI1(2,3,2)=-B
      VAFI1(1,1,1)=1D0
      VAFI1(1,2,1)=-2D0/3D0
      VAFI1(1,3,1)=1D0/3D0
      VAFI1(1,1,2)=B*(4D0*SWEFF2-1D0)
      VAFI1(1,2,2)=B*(1D0-8D0*SWEFF2/3D0)
      VAFI1(1,3,2)=B*(4D0*SWEFF2/3D0-1D0)
 
C..LEPTONIC QED VERTEX CORRECTIONS INCLUDING SOFT BREMSSTRAHLUNG
      IF (LPAR(12).GE.1) THEN
        DVRTXV=HSDQDV(X,Q2)*ALP2PI
        DVRTXS=HSDQDS(X,Q2)*ALP2PI
        DVRTX1=DVRTXV-(Q2+4D0*MEI2)/(Q2-2D0*MEI2)*DVRTXS
        DVRTX2=DVRTXV+
     *         (2D0*(1D0-Y)+Y*Y/2D0)/(1D0-Y-MPRO2*Q2/SHAT/SHAT)*DVRTXS
        ELSE
        DVRTX1=0D0
        DVRTX2=0D0
      ENDIF

      INDV = 1
      INDA = 2
      IEL=1
      DO 1 IF=1,3
        DO 1 IB1=1,2
          DO 1 IB2=1,2
          FLIND1(INDV,IF,IB1,IB2)=
     *     2D0*(VAFI1(INDV,IF,IB1)*VAFI1(INDV,IF,IB2)
     *         +VAFI1(INDA,IF,IB1)*VAFI1(INDA,IF,IB2))
          FLIND1(INDA,IF,IB1,IB2)=
     *     2D0*(VAFI1(INDV,IF,IB1)*VAFI1(INDA,IF,IB2)
     *         +VAFI1(INDA,IF,IB1)*VAFI1(INDV,IF,IB2))
    1 CONTINUE
      DO 2 IVB1=1,2
       DO 2 IVB2=1,2
        DO 2 IFERM=2,3
        AFIJ1(IFERM,IVB1,IVB2)=FLIND1(INDV,IFERM,IVB1,IVB2)
     *  *(FLIND1(INDV,IEL,IVB1,IVB2)-POLARI*FLIND1(INDA,IEL,IVB1,IVB2))
        BFIJ1(IFERM,IVB1,IVB2)=FLIND1(INDA,IFERM,IVB1,IVB2)
     *  *(FLIND1(INDA,IEL,IVB1,IVB2)-POLARI*FLIND1(INDV,IEL,IVB1,IVB2))
    2  CONTINUE
C
      DO 3 IB1=1,2
       DO 3 IB2=1,2
       IF (LPAR(3).LT.3) THEN
       F1(IB1,IB2)=
     &   (AFIJ(2,IB1,IB2)*(QUT+QUBT)+AFIJ(3,IB1,IB2)*(QDT+QDBT))
     &     /8D0*DSBOS(IB1)*DSBOS(IB2)*DVRTX1
     &  +(AFIJ1(2,IB1,IB2)*(QUT+QUBT)+AFIJ1(3,IB1,IB2)*(QDT+QDBT))
     &     /8D0*DSBS1(IB1)*DSBS1(IB2)
       F2(IB1,IB2)=2D0*X*(
     &   (AFIJ(2,IB1,IB2)*(QUT+QUBT)+AFIJ(3,IB1,IB2)*(QDT+QDBT))
     &     /8D0*DSBOS(IB1)*DSBOS(IB2)*DVRTX2
     &  +(AFIJ1(2,IB1,IB2)*(QUT+QUBT)+AFIJ1(3,IB1,IB2)*(QDT+QDBT))
     &     /8D0*DSBS1(IB1)*DSBS1(IB2))
       F3(IB1,IB2)=
     &   (BFIJ(2,IB1,IB2)*(QUT-QUBT)+BFIJ(3,IB1,IB2)*(QDT-QDBT))
     &     /4D0*DSBOS(IB1)*DSBOS(IB2)*DVRTX1
     &  +(BFIJ1(2,IB1,IB2)*(QUT-QUBT)+BFIJ1(3,IB1,IB2)*(QDT-QDBT))
     &     /4D0*DSBS1(IB1)*DSBS1(IB2)
      ELSE
       F1(IB1,IB2)=
     &   (AFIJ1(2,IB1,IB2)*(QUT+QUBT)+AFIJ1(3,IB1,IB2)*(QDT+QDBT))
     &     /8D0*DSBS1(IB1)*DSBS1(IB2)*(1D0+DVRTX1)
       F2(IB1,IB2)=2D0*X*
     &   (AFIJ1(2,IB1,IB2)*(QUT+QUBT)+AFIJ1(3,IB1,IB2)*(QDT+QDBT))
     &     /8D0*DSBS1(IB1)*DSBS1(IB2)*(1D0+DVRTX2)
       F3(IB1,IB2)=
     &   (BFIJ1(2,IB1,IB2)*(QUT-QUBT)+BFIJ1(3,IB1,IB2)*(QDT-QDBT))
     &     /4D0*DSBS1(IB1)*DSBS1(IB2)*(1D0+DVRTX1)
      ENDIF
  3   CONTINUE
      F2EM=X*(AFIJ(2,1,1)*(QUT+QUBT)+AFIJ(3,1,1)*(QDT+QDBT))/4D0

C---INCLUDE LONGITUDINAL STRUCTURE FUNCTION
 2000 CONTINUE
      IF (IFLOPT.GT.0) THEN
        FL=0D0
        Q2L=Q2
        IF (Q2L.LT.TTR) THEN
          Q2L=TTR
          XP21=SNGL(X)*SNGL(SP-MPRO2-MEI2)
          IF (Q2L.GE.XP21) Q2L=XP21
        ENDIF
        CALL HSLUFL(X,Q2L,F2EM,FL)
        IF (LPAR(3).LT.3) THEN
          F1(1,1)=(F2EM-FL)/2D0/X*(DVRTX1+DSBS1(1)*DSBS1(1))
          ELSE
          F1(1,1)=(F2EM-FL)/2D0/X*(1D0+DVRTX1)*DSBS1(1)*DSBS1(1)
        ENDIF
        IF (F1(1,1).LT.0D0) F1(1,1)=0D0
      ENDIF

      IF (HNA.EQ.1D0.AND.HNZ.EQ.1D0) THEN
        CONTINUE
      ELSEIF (HNA.EQ.1D0.AND.HNZ.EQ.0D0) THEN
C--->   CORRECT FOR RATIO F2(NEUTRON)/F2(PROTON)
      ELSE
C---NUCLEAR SHADOWING FOR HEAVY NUCLEI
        DO 11 IB1=1,2
         DO 11 IB2=1,2
         HNRAT=HSNRAT(X)
         F1(IB1,IB2)=F1(IB1,IB2)*HNRAT
         F2(IB1,IB2)=F2(IB1,IB2)*HNRAT
   11   CONTINUE
      ENDIF

C---APPLY LOW Q2 SUPPRESSION
C   MOVED TO LYSTFU
      RETURN
      END
